---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "decort_cb_disk Resource - terraform-provider-decort"
subcategory: ""
description: |-
  
---

# decort_cb_disk (Resource)





<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `account_id` (Number)
- `disk_name` (String)
- `size_max` (Number)

### Optional

- `desc` (String)
- `detach` (Boolean) detach disk from machine first
- `iops` (Number) max IOPS disk can perform
- `iotune` (Block List, Max: 1) (see [below for nested schema](#nestedblock--iotune))
- `node_ids` (Set of Number)
- `permanently` (Boolean) whether to completely delete the disk, works only with non attached disks
- `pool` (String)
- `restore` (Boolean) restore deleting disk
- `sep_id` (Number)
- `shareable` (Boolean)
- `timeouts` (Block, Optional) (see [below for nested schema](#nestedblock--timeouts))

### Read-Only

- `account_name` (String)
- `acl` (String)
- `boot_partition` (Number)
- `computes` (List of Object) (see [below for nested schema](#nestedatt--computes))
- `created_by` (String)
- `created_time` (Number)
- `deleted_by` (String)
- `deleted_time` (Number)
- `destruction_time` (Number)
- `devicename` (String)
- `disk_id` (Number)
- `disk_path` (String)
- `gid` (Number)
- `guid` (Number)
- `id` (String) The ID of this resource.
- `image_id` (Number)
- `images` (List of String)
- `iqn` (String)
- `login` (String)
- `machine_id` (Number)
- `machine_name` (String)
- `milestones` (Number)
- `order` (Number)
- `params` (String)
- `parent_id` (Number)
- `passwd` (String)
- `pci_slot` (Number)
- `present_to` (Map of Number)
- `purge_attempts` (Number)
- `purge_time` (Number)
- `reality_device_number` (Number)
- `reference_id` (String)
- `replication` (List of Object) Replication status (see [below for nested schema](#nestedatt--replication))
- `res_id` (String)
- `res_name` (String)
- `role` (String)
- `sep_type` (String)
- `size_used` (Number)
- `snapshots` (List of Object) (see [below for nested schema](#nestedatt--snapshots))
- `status` (String)
- `tech_status` (String)
- `type` (String) The type of disk in terms of its role in compute: 'B=Boot, D=Data, T=Temp'
- `updated_by` (String)
- `updated_time` (Number)
- `vmid` (Number)

<a id="nestedblock--iotune"></a>
### Nested Schema for `iotune`

Optional:

- `read_bytes_sec` (Number)
- `read_bytes_sec_max` (Number)
- `read_iops_sec` (Number)
- `read_iops_sec_max` (Number)
- `size_iops_sec` (Number)
- `total_bytes_sec` (Number)
- `total_bytes_sec_max` (Number)
- `total_iops_sec` (Number)
- `total_iops_sec_max` (Number)
- `write_bytes_sec` (Number)
- `write_bytes_sec_max` (Number)
- `write_iops_sec` (Number)
- `write_iops_sec_max` (Number)


<a id="nestedblock--timeouts"></a>
### Nested Schema for `timeouts`

Optional:

- `create` (String)
- `default` (String)
- `delete` (String)
- `read` (String)
- `update` (String)


<a id="nestedatt--computes"></a>
### Nested Schema for `computes`

Read-Only:

- `compute_id` (String)
- `compute_name` (String)


<a id="nestedatt--replication"></a>
### Nested Schema for `replication`

Read-Only:

- `disk_id` (Number)
- `pool_id` (String)
- `role` (String)
- `self_volume_id` (String)
- `storage_id` (String)
- `volume_id` (String)


<a id="nestedatt--snapshots"></a>
### Nested Schema for `snapshots`

Read-Only:

- `guid` (String)
- `label` (String)
- `reference_id` (String)
- `res_id` (String)
- `snap_set_guid` (String)
- `snap_set_time` (Number)
- `timestamp` (Number)
