/*
Пример использования
Управление правилами трансляции сетевых портов для виртуальных серверов
Ресурс позволяет:
1. Создавать правила для трансляции сетевых портов
*/

#Раскомментируйте этот код,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером
/*
terraform {
  required_providers {
    decort = {
      source = "basis/decort/decort"
      version = "<VERSION>"
    }
  }
}
*/

provider "decort" {
  authenticator = "decs3o"
  #controller_url = <DECORT_CONTROLLER_URL>
  controller_url = "https://ds1.digitalenergy.online"
  #oauth2_url = <DECORT_SSO_URL>
  oauth2_url           = "https://sso.digitalenergy.online"
  allow_unverified_ssl = true
}

resource "decort_pfw" "pfw" {
  #id виртуальной машины
  #обязательный параметр
  #тип - целое число
  #используется при создании
  compute_id = 11269

  #начальный порт правила
  #обязательный параметр
  #тип - целое число
  #используется при создании
  public_port_start = 200

  #внутренний порт
  #обязательный параметр
  #тип - целое число
  #используется при создании
  local_base_port = 22

  #протокол соединения (tcp / udp)
  #обязательный параметр
  ##тип - строка
  #используется при создании
  proto = "tcp"

  #конечный порт (включительно)
  #опциональный параметр
  #тип - целое число
  #используется при создании
  #public_port_end = 21321

}

output "pfw_out" {
  value = decort_pfw.pfw
}
