Функция доступна в провайдере версии 4.5.1 и выше.

_Resource_ функция **decort_cb_pcidevice** служит для управления устройств с шиной PCI. Функция позволяет:
- Создать устройство
- Удалить устройство
- Включить/отключить устройство

## Аргументы

_Resource_ функция **decort_cb_pcidevice** принимает следующие аргументы:

| Аргумент      | Тип    | Обязательный       | Описание                                                                                       |
|---------------|--------|--------------------|------------------------------------------------------------------------------------------------|
| name          | string | :heavy_check_mark: | Имя устройства                                                                                 |
| hw_path       | string | :heavy_check_mark: | Путь до устройства (HW Path)                                                                   |
| rg_id         | int    | :heavy_check_mark: | id ресурсной группы устройства                                                                 |
| stack_id      | int    | :heavy_check_mark: | id стака устройства                                                                            |
| description   | string | :x:                | Описание устройства                                                                            |
| enable        | bool   | :x:                | Доступность устройства, может использоваться на уже созданном ресурсе                          |
| force_disable | bool   | :x:                | Принудительное отключение устройства, используется при отключении устройства                   |
| force_delete  | bool   | :x:                | Принудительное удаление устройства, используется при удалении устройства                       |
| device_id     | int    | :x:                | id устройства, может быть использовано для формирования .tfstate, при наличии ресурса в облаке |

## Возвращаемые значения

В случае успешного выполнения _resource_ функция **decort_cb_pcidevice** возвращает в указанную при вызове переменную элемент, который состоит из следующих параметров:

| Параметр    | Тип      | Описание                             |
|-------------|----------|--------------------------------------|
| ckey        | string   | CKey                                 |
| meta        | []string | Мета информация                      |
| compute_id  | int      | id вычислительной площадки           |
| description | string   | Описание                             |
| guid        | int      | Внутренний id                        |
| hw_path     | string   | HW Путь                              |
| device_id   | int      | id устройства                        |
| name        | string   | Наименование устройства              |
| rg_id       | int      | id ресурсной группы (resource group) |
| stack_id    | int      | id стэка                             |
| status      | string   | Статус устройства                    |
| system_name | string   | Системное имя устройства             |

## Пример использования

Пример вызова _resource_ функции **decort_cb_pcidevice**:

```terraform
resource "decort_cb_pcidevice" "pd" {
  name = "test_device"
  hw_path = "0000:01:00.0"
  description = "test desc"
  rg_id = 11111
  stack_id = 11

  #enable = false
  #force_disable = true
  #force_delete = true
}
# once the above directive completes, pcidevice will be accessible
# as decort_cb_pcidevice.pd
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.2/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_cb_pcidevice** в переменной `decort_cb_pcidevice.pd` будут сохранены возвращаемые значения.
