Функция доступна в провайдере версии 4.5.1 и выше.

_Resource_ функция **decort_cb_disk_snapshot** служит для управления снимками данных диска. Функция позволяет:
- Получить снимок
- Удалить снимок
- Произвести "откат" диска к этому снимку

## Аргументы
_Resource_ функция **decort_cb_disk_snapshot** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание                                                                           |
| --- | --- | :---: |------------------------------------------------------------------------------------|
| disk_id | int | :heavy_check_mark: | ID диска, к которому принадлежит снимок                                            |
| label | string | :heavy_check_mark: | Название снимка                                                                    |
| rollback | bool | :x: | Откат диска. Происходит только при изменении с false на true. По умолчанию - false |
| timestamp | int | :x: | Время отката. Используется только при осуществлении отката                         |

## Возвращаемые значения
В случае успешного выполнения _resource_ функция **decort_cb_disk_snapshot** возвращает в указанную при вызове переменную элемент, который состоит из следующих параметров:

| Параметр | Тип    | Описание |
| --- |--------| --- |
| disk_id | int    | ID диска, к которому принадлежит снимок |
| label | string | Название снимка |
| rollback | bool   | Откат диска. Происходит только при изменении с false на true. По умолчанию - false |
| timestamp | int    | Время отката. Используется только при осуществлении отката |
| guid | string | ID снимка |
| reference_id | string | ID ссылки |
| res_id | string | Ссылка на снимок |
| snap_set_guid | string | ID набора снимков, в котором лежит снимок состояния |
| snap_set_time | int    | Время набора |

## Пример использования
Пример вызова _resource_ функции **decort_cb_disk_snapshot**:
```terraform
resource "decort_cb_disk_snapshot" "ds" {
  disk_id = 20100
  label = "label"
  #rollback = false
  #timestamp = 15
}
```

После успешного завершения такого вызова **decort_cb_disk_snapshot** в переменной `decort_cb_disk_snapshot.ds` будут сохранены возвращаемые значения.
