Функция доступна в провайдере версии 2.1 и выше.

_Data source_ функция **decort_snapshot_list** служит для получения информации об имеющихся снапшотах у переданной в аргументах вычислительной платформы. Снапшот позволяет делать снимки данных с диска, а после этого их восстанавливать. Для успешного восстановления данных через снапшот, необходимо убедиться, что [compute](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.3/07.01.01-Resource_decort_kvmvm.md) (вычислительные мощности) остановлен.

## Аргументы
_Data source_ функция **decort_snapshot_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| compute_id | int | :heavy_check_mark: | ID вычислительной мощности |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_snapshot_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| guid | string | Guid снапшота |
| label | string | Наименование снапшота |
| timestamp | int | Время создания снапшота |
| disks | []int | Диски снапшота |


## Пример использования
Пример вызова _data source_ функции **decort_snapshot_list**:
```terraform
data "decort_snapshot_list" "sl" {
  compute_id = 24074
}
# once the above directive completes, snapshot list will be accessible 
# as data.decort_snapshot_list.sl.items
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.3/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_snapshot_list** в переменной `data.decort_snapshot_list.sl` будут сохранены возвращаемые значения.
