Функция доступна в провайдере версии 2.3 и выше.

_Data source_ функция **decort_account_consumed_units_by_type** служит для получения информации об используемых ресурсах по типу переданного ресурса.

## Аргументы
_Data source_ функция **decort_account_consumed_units_by_type** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| account_id | int | :heavy_check_mark: | ID аккаунта |
| cu_type | string | :heavy_check_mark: | Тип ресурса<br/>cu_c - кол-во ядер<br/>cu_d - размер диска, ГБ<br/>cu_m - размер RAM, МБ<br/>cu_i - кол-во публичных IP-адресов<br/>cu_np - кол-во полученного/отданного трафика, в ГБ<br/>gpu_units - кол-во графических ядер |


## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_account_consumed_units_by_type** возвращает следующие параметры:

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | ID аккаунта |
| cu_type | string | Тип ресурса<br/>cu_c - кол-во ядер<br/>cu_d - размер диска, ГБ<br/>cu_m - размер RAM, МБ<br/>cu_i - кол-во публичных IP-адресов<br/>cu_np - кол-во полученного/отданного трафика, в ГБ<br/>gpu_units - кол-во графических ядер |
| cu_result | float | Информация о ресурсе |

## Пример использования
Пример вызова _data source_ функции **decort_account_consumed_units_by_type**:
```terraform
data "decort_account_consumed_units_by_type" "acubt" {
  #id аккаунта
  #обязательный параметр
  #тип - число
  account_id = 88366

  #тип вычислительной еденицы
  #обязательный параметр
  #тип - строка
  #значения:
  #cu_c - кол-во виртуальных cpu ядер
  #cu_m - кол-во RAM в МБ
  #cu_d - кол-в используемой дисковой памяти, в ГБ
  #cu_i - кол-во публичных ip адресов
  #cu_np - кол-во полученного/отданного трафика, в ГБ
  #gpu_units - кол-во gpu ядер
  cu_type = "cu_с"
}
# once the above directive completes, consumed units by type info will be accessible 
# as data.decort_account_consumed_units_by_type.acubt
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.3/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_account_consumed_units_by_type** в переменной `data.decort_account_consumed_units_by_type.acubt` будут сохранены возвращаемые значения.
