Функция доступна в провайдере версии 2.3 и выше.

_Data source_ функция **decort_account_disks_list** служит для получения информации об используемых аккаунтом дисках.

## Изменения в версии 3.4.0
- В возвращаемые значения добавлено поле shareable

## Аргументы
_Data source_ функция **decort_account_disks_list** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| account_id | int | :heavy_check_mark: | ID аккаунта |
| disk_id | int | :x: | Фильтр по ID диска |
| name | string | :x: | Фильтр по имени диска |
| disk_max_size | int | :x: | Фильтр по макс. размеру диска |
| type | string | :x: | Фильтр по типу диска |
| page | int | :x: | Номер страницы |
| size | int | :x: | Размер страницы |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_account_disks_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| disk_id | int | ID диска |
| disk_name | string | Название диска |
| pool | string | Название пула, к которому относится диск |
| sep_id | int | ID sep |
| shareable | bool | Флаг, говорящий о том, является ли диск общим |
| size_max | int | Максимальный размер диска |
| type | string | Тип диска |

## Пример использования
Пример вызова _data source_ функции **decort_account_disks_list**:
```terraform
data "decort_account_disks_list" "adl" {
  #id аккаунта
  #обязательный параметр
  #тип - число
  account_id = 11111

  #Фильтр по максимальному размеру диска
  #опциональный параметр
  #тип - число
  disk_max_size = 50
}
# once the above directive completes, account disks list will be accessible 
# as data.decort_account_disks_list.adl.items
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.3/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_account_disks_list** в переменной `data.decort_account_disks_list.adl` будут сохранены возвращаемые значения.
