Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_k8s_wg** служит для получения информации о группе воркеров кластера Kubernetes (k8s).

## Аргументы

_Data source_ функция **decort_cb_k8s_wg** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| k8s_id | int | :heavy_check_mark: | ID кластера |
| wg_id | int | :heavy_check_mark: | ID группы воркеров |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_cb_k8s_wg** возвращает следующие параметры:

| Параметр | Тип                                                             | Описание |
| --- |-----------------------------------------------------------------| --- |
| k8s_id | int                                                             | ID кластера |
| wg_id | int                                                             | ID группы воркеров |
| name | string                                                          | Имя группы воркеров |
| num  | int                                                             | кол-во компьютов в ресурсе |
| cpu  | int                                                             | Кол-во cpu на нодах |
| ram  | int                                                             | Кол-во ram на нодах |
| disk | int                                                             | ID диска |
| detailed_info | []Struct{} [см. ниже](#описание-структуры-списка-detailed_info) | Детальная информация masters |
| labels | []string                                                        | Лейблы ресурса |
| guid | string                                                          | ID ресурса |
| annotations | []string                                                        | Аннотации ресурса |
| taints | []string                                                        | ограничители группы workers |

### Описание структуры списка detailed_info

| Параметр | Тип | Описание |
| --- | --- | --- |
| external_ip    | string | Внешний ip                                             |
| compute_id | int | ID компьюта в составе группы |
| name | string | Имя компьюта в составе группы |
| status | string | Статус компьюта в составе группы |
| tech_status | string | Технический статус компьюта в составе группы |
| interfaces | []Struct{} [см. ниже](#описание-структуры-списка-interfaces) | Список интерфейсов группы |

### Описание структуры списка interfaces

| Параметр | Тип | Описание |
| --- | --- | --- |
| def_gw | string | Шлюз по умолчанию |
| ip_address | string | IP интерфейса |

## Пример использования

Пример вызова _data source_ функции **decort_cb_k8s_wg**:

```terraform
data "decort_cb_k8s_wg" "k8s_wg" {
  #id кластера
  #обязательный параметр
  #тип - число
  k8s_id = 49304

  #id группы воркеров
  #обязательный параметр
  #тип - число
  wg_id = 43329
}
```

После успешного завершения такого вызова **decort_cb_k8s_wg** в переменной `data.decort_cb_k8s_wg.k8s_wg` будут сохранены возвращаемые значения.

