Функция доступна в провайдере версии 2.1 и выше.

_Resource_ функция **decort_snapshot** служит для управления снапшотами. Снапшот позволяет делать снимки данных с диска, а после этого их восстанавливать. Для успешного восстановления данных через снапшот, необходимо убедиться, что [compute](link will available soon) (вычислительные мощности) остановлен.

## Аргументы
_Resource_ функция **decort_snapshot** для создания снапшота принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| compute_id | int | :heavy_check_mark: | ID вычислительной мощности |
| label | string | :heavy_check_mark: | Наименование снапшота |
| rollback | bool | :x: | Флаг отката<br/>по-умолчанию - false<br/>если флаг был изменен с false на true,<br/>то произойдет восстановление данных из снапшота<br/>Флаг используется после создания ресурса. |

## Возвращаемые значения
В случае успешного выполнения _resource_ функция **decort_snapshot** возвращает в указанную при вызове переменную следующие значения:

| Параметр | Тип | Описание |
| --- | --- | --- |
| guid | string | Guid снапшота |
| label | string | Наименование снапшота |
| timestamp | int | Время создания снапшота |
| disks | []int | Диски снапшота |

## Пример использования
Пример вызова _resource_ функции **decort_snapshot**:
```terraform
resource "decort_snapshot" "s" {
  compute_id = 11111
  label = "test_ssht_3"
  #rollback = false
}

# once the above directive completes, cdrom image will be accessible 
# as decort_snapshot.s
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.3/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_snapshot** в переменной `decort_snapshot.s` будут сохранены возвращаемые значения.
