Функция доступна в провайдере версии 4.6.0 и выше.

*Data source* функция **decort_cb_user** служит для получения информации о пользователе.



## Аргументы

*Data source* функция **decort_cb_user** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| user_id | string | :heavy_check_mark: | ID пользователя |

## Возвращаемые значения

В случае успешного выполнения *data source* функция **decort_cb_user** возвращает в указанную при вызове переменную элемент, который состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| user_id | string | ID пользователя |
| ckey | string | CKey |
| meta | []string | Мета информация об user |
| active | bool | Флаг активности |
| api_access | map[string]string | Список групп доступа к API, в которые будет включен данный пользователь |
| authkey | string | Ключ сеанса |
| authkeys | []string | Список ключей сеанса |
| data | string | Установленные данные |
| description | string | Описание |
| domain | string | Имя домена |
| emails | []string | Список адресов электронной почты |
| gid | int | Grid ID |
| groups | []string | Список групп, в которые включен пользователь |
| guid | string | Guid пользователя |
| last_check | int | Дата последней проверки |
| mobile | []string | Список мобильных номеров |
| password | string | Пароль пользователя |
| protected | bool | Protected |
| roles | []string | Список ролей |
| service_account | bool | Флаг, является ли аккаунт аккаунтом-обслуживания |
| xmpp | []string | Xmpp |

## Пример использования

Пример вызова *data source* функции **decort_cb_user**:

```terraform
data "decort_cb_user" "user" {
  #id пользователя
  #обязательный параметр
  #тип - строка
  user_id = "<USER_ID>"
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_cb_user** в переменной `data.decort_cb_user.user` будут сохранены возвращаемые значения.
