Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_account_audits_list** служит для получения информации о запросах аккаунта.  
Информация содержит в себе данные о вызове, времени выполнения запроса, пользователе, инициирующем вызов, а так же другие данные.

## Аргументы

_Data source_ функция **decort_cb_account_audits_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| account_id | int | :heavy_check_mark: | ID аккаунта |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_cb_account_audits_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| call | string | Адрес вызова API |
| responsetime | float | Время ответа |
| statuscode | int | Код ответа |
| timestamp | float | Время получения запроса |
| user | string | Пользователь - владелец аккаунта |

## Пример использования

Пример вызова _data source_ функции **decort_cb_account_audits_list**:

```terraform
data "decort_cb_account_audits_list" "aal" {
  #id аккаунта
  #обязательный параметр
  #тип - целое число
  account_id = 11111
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_cb_account_audits_list** в переменной `data.decort_cb_account_audits_list.aal.items` будут сохранены возвращаемые значения.
