Функция доступна в провайдере версии 3.0 и выше.

_Data source_ функция **decort_locations_list** служит для получения информации об имеющихся в облачной платформе площадках(grid). Grid это пространства, на которых возможно размещение виртуальных машин.

## Аргументы

_Data source_ функция **decort_locations_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| flag | string | :x: | Поиск по флагу |
| name | string | :x: | Поиск по имени |
| by_id | int | :x: | Поиск по ID |
| location_code | string | :x: | Поиск по коду локации |
| page | int | :x: | Номер страниц |
| size | int | :x: | Размер страницы |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_locations_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| auth_broker | []string | auth broker |
| flag | string | Флаг |
| gid | int | ID grid |
| guid | int | Внутренний id |
| id | int | ID |
| location_code | string | Код расположения grid |
| name | string | Наименование grid |

## Пример использования

Пример вызова _data source_ функции **decort_locations_list**:

```terraform
data "decort_locations_list" "ll" {
  #фильтр по флагу
  #опицональный параметр 
  #тип - строка
  #flag = "some"
  
  #фильтр по id локации
  #опциональный параметр
  #тип - целое число
  #by_id = 100

  #фильтр по имени локации
  #опциональный параметр
  #тип - строка
  #name = "test"

  #фильтр по коду локации
  #опциональный параметр
  #тип - строка
  #location_code = "europe"

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #тип - строка
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #sort_by = "+name"

  #кол-во страниц для вывода
  #опицональный параметр 
  #тип - целое число
  #page = 1

  #размер страницы
  #опицональный параметр 
  #тип - целое число
  #size = 1
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.1/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_locations_list** в переменной `data.decort_locations_list.ll` будут сохранены возвращаемые значения.
