Функция доступна в провайдере версии 2.3 и выше.

_Data source_ функция **decort_extnet** служит для получения информации о внешней сети.

## Аргументы
_Data source_ функция **decort_extnet** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| net_id | int | :heavy_check_mark: | Идентификатор сети |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_extnet** возвращает следующие параметры:

| Параметр | Тип | Описание |
| --- | --- | --- |
| net_id | int | ID сети |
| meta | []string | Мета информация |
| check_ips | []string | Список ip адресов для проверки |
| default | bool | Является ли сеть сетью по-умолчанию |
| default_qos | Struct{<br/>e_rate int<br/>guid string<br/>in_burst int<br/>in_rate int<br/>} | Quality of Service по-умолчанию<br/>Минимальное кол-во потерь<br/>id сервиса<br/>Потери в режиме burst<br/>Потери в режиме rate<br/>&nbsp;<br/> |
| desc | string | Описание |
| dns | []string | Список dns |
| excluded | []string | Список исключенных ip-адресов |
| free_ips | int | Кол-во свободных ip-адресов |
| gateway | string | Сетевые врата |
| gid | int | Grid id |
| guid | int | Внутренний id сети |
| ipcidr | string | Маска сети |
| milestones | int | Время жизни |
| net_name | string | Имя сети |
| network | string | Информация о сети |
| network_id | int | Идентификатор сети |
| pre_reservations_num | int | Количество зарезервированных ресурсов |
| prefix | int | Префикс |
| pri_vnf_dev_id | int | ID внутренней сети для разработки |
| reservations | []Struct{<br/>client_type string<br/>domainname string<br/>hostname string<br/>desc string<br/>ip string<br/>mac string<br/>type string<br/>vm_id int<br/>} | Зарезервированные части сети<br/>Тип клиента<br/>Имя домена<br/>Имя хоста<br/>Описание<br/>IP-адрес<br/>MAC-адрес<br/>Тип  <br/>ID виртуальной машины<br/>&nbsp;<br/> |
| shared_with | []int | Список ресурсов, имеющих доступ к сети |
| status | string | Статус сети |
| vlan_id | int | Идентификатор vlan |
| vnfs | Struct{<br/>dhcp int<br/>} | Информация о vnfs<br/>Информация о dhcp<br/>&nbsp;<br/> |

## Пример использования
Пример вызова _data source_ функции **decort_extnet**:
```terraform
data "decort_extnet" "e" {
  #идентификатор сети
  #обязательный параметр
  #тип - целое число
  net_id = 1111
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.1/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_extnet** в переменной `data.decort_extnet.e` будут сохранены возвращаемые значения.
