Функция доступна в провайдере версии 4.5.1 и выше.

_Resource_ функция **decort_cb_lb_frontend_bind** служит для управления привязкой фронтенда балансировщиком нагрузки (load balancer). Балансировщики нагрузки служат для равномерного распределения сетевой нагрузки между подключенными к ним сервисами. 

## Аргументы
_Resource_ функция **decort_cb_lb_frontend_bind** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| lb_id | int | :heavy_check_mark: | ID балансировщика нагрузки |
| name | string | :heavy_check_mark: | Название фронтенда |
| frontend_name | string | :heavy_check_mark: | Название фронтенда балансировщика |
| address | string | :heavy_check_mark: | IP адрес привязки |
| port | int | :heavy_check_mark: | Порт привязки |


## Возвращаемые значения
В случае успешного выполнения _resource_ функция **decort_cb_lb_frontend_bind** возвращает в указанную при вызове переменную элемент, который состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| address | string | Адрес, к которому привязан фронтенд |
| name | string | Имя привязки |
| frontend_name | string | Название фронтенда |
| lb_id | int | ID балансировщика |
| port | int | Порт привязки |
| guid | string | ID ресурса |

## Импортирование ресурса
Так как ресурс lb_frontend_bind является подресурсом lb_frontend, то для его импорта необходимо указать ID балансировщика, имя фронтенда, а так же само имя ресурса.  
Общая схема:
```terraform
terraform import decort_cb_lb_frontend_bind.<var> <lb_id>#<frontend-name>#<binding-name>
```
Пример:
```
terraform import decort_cb_lb_frontend_bind.lb 777#testFrontend#testBinding
```

## Ограничение на наименование ресурса
Ресурс не должен содержать в названии символ `#`

## Пример использования
Пример вызова _resource_ функции **decort_cb_lb_frontend_bind**:
```terraform
resource "decort_cb_lb_frontend_bind" "lbfb" {
  #id балансировщика нагрузок
  #обязательный параметр
  #тип - целое число
  lb_id = 777

  #имя фронтенда для создания привязки
  #обязательный параметр
  #тип - строка
  frontend_name = "testFrontend"

  #наименование привязки
  #обязательный параметр
  #тип - строка
  name = "testBinding"

  #адрес привязки фронтенда
  #обязательный параметр
  #тип - строка
  address = "111.111.111.111"

  #порт для привязки фронтенда
  #обязательный параметр
  #тип - целое число
  port = 1111
}
```

После успешного завершения такого вызова **decort_cb_lb_frontend_bind** в переменной `decort_cb_lb_frontend_bind.lbfb` будут сохранены возвращаемые значения.
