Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_pcidevice_list** служит для получения информации об имеющихся устройств с шиной PCI.

## Аргументы
_Data source_ функция **decort_cb_pcidevice_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| by_id | int | :x: | фильтр по ID устройства |
| compute_id | int | :x: | фильм по ID вычислительной машины |
| name | string | :x: | фильтр по наименованию устройства |
| rg_id | int | :x: | фильтр по ID ресурсной группы |
| status | string | :x: | фильтр по статусу устройства |
| page | int | :x: | Номер страницы для вывода |
| size | int | :x: | Размер страницы для вывода |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_pcidevice_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| ckey | string | CKey |
| meta | []string | Мета информация |
| compute_id | int | id вычислительной площадки |
| description | string | Описание |
| guid | int | Внутренний id |
| hw_path | string | HW Путь |
| device_id | int | id устройства |
| name | string | Наименование устройства |
| rg_id | int | id ресурсной группы (resource group) |
| stack_id | int | id стэка |
| status | string | Статус устройства |
| system_name | string | Системное имя устройства |


## Пример использования

Пример вызова _data source_ функции **decort_cb_pcidevice_list**:

```terraform
data "decort_cb_pcidevice_list" "pl" {
  #фильтр по id устройства
  #опциональный параметр
  #тип - целое число
  #by_id = 111

  #фильтр по id Compute
  #опциональный параметр
  #тип - целое число
  #compute_id = 123

  #фильтр по имени устройства
  #опциональный параметр
  #тип - строка
  #name = "name"

  #фильтр по id ресурсной группы
  #опциональный параметр
  #тип - целое число
  #rg_id = 111

  #фильтр по статусу устройства
  #опциональный параметр
  #тип - строка
  #status = "status"

  #номер страницы для отображения
  #опциональный параметр
  #тип - целое число
  #page = 2

  #размер страницы
  #опциональный параметр
  #тип - целое число
  #size = 3
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.2/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_cb_pcidevice_list** в переменной `data.decort_cb_pcidevice_list.pl` будут сохранены возвращаемые значения.
