Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_flipgroup** служит для получения информации о группе с плавающим ip-адресом.

## Аргументы

_Data source_ функция **decort_cb_flipgroup** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| flipgroup_id | int | :heavy_check_mark: | ID группы с плавающим ip-адресом (flipgroup) |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_cb_flipgroup** возвращает в указанную при вызове переменную, которая состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | ID аккаунта - владельца группы с плавающим ip-адресом |
| account_name | string | Имя аккаунта - владельца группы с плавающим ip-адресом |
| client_ids | []int | Список ID клиентов группы с плавающим ip-адресом |
| client_names | []string | Список имен клиентов группы с плавающим ip-адресом |
| client_type | string | Тип клиента |
| conn_id | int | ID подключения |
| conn_type | string | Тип подключения |
| created_by | string | Информация о том, кто создал группу с плавающим ip-адресом |
| created_time | int | Время создания группы с плавающим ip-адресом |
| default_gw | string | Шлюз по умолчанию |
| deleted_by | string | Информация о том, кто удалил группу с плавающим ip-адресом |
| deleted_time | int | Время удаления группы с плавающим ip-адресом |
| description | string | Описание группы |
| gid | int | Идентификатор площадки (grid id) |
| guid | int | ID ресурса |
| flipgroup_id | int | ID группы с плавающим ip-адресом |
| ip | string | IP адрес |
| milestones | int | Вехи |
| name | string | Название группы с плавающим ip-адресом |
| net_id | int | ID сети |
| net_type | string | Тип сети |
| network | string | Сеть |
| rg_id | int | ID ресурсной группы |
| rg_name | string | Название ресурсной группы |
| status | string | Статус группы с плавающим ip-адресом |
| updated_by | string | Информация о том, кто обновил группу с плавающим ip-адресом |
| updated_time | int | Время обновления группы с плавающим ip-адресом |

## Пример использования

Пример вызова _data source_ функции **decort_cb_flipgroup**:

```terraform
data "decort_cb_flipgroup" "fg" {
  #id флипгруппы
  #обязательный параметр
  #тип - целое число
  flipgroup_id = 1111
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.2/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_cb_flipgroup** в переменной `data.decort_cb_flipgroup.fg` будут сохранены возвращаемые значения.
