Функция доступна в провайдере версии 2.3 и выше.

_Data source_ функция **decort_account_reserved_units** служит для получения информации о зарезервированных ресурсах аккаунта.

## Аргументы
_Data source_ функция **decort_account_reserved_units** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| account_id | int | :heavy_check_mark: | ID аккаунта |


## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_account_reserved_units** возвращает следующие параметры:

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | ID аккаунта |
| cu_c | float | Кол-во ядер |
| cu_d | float | Размер диска, ГБ |
| cu_i | float | Кол-во публичных ip-адресов |
| cu_m | float | Размер RAM, МБ |
| cu_dm | float | Использованный размер хранилища виртуального диска |
| cu_np | float | Кол-во полученного/отданного трафика, ГБ |
| gpu_units | float | Кол-во графических ядер |


## Пример использования
Пример вызова _data source_ функции **decort_account_reserved_units**:
```terraform
data "decort_account_reserved_units" "aru" {
  #id аккаунта
  #обязательный параметр
  #тип - целое число
  account_id = 11111
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.3/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_account_reserved_units** в переменной `data.decort_account_reserved_units.aru` будут сохранены возвращаемые значения.
