Ресурсы в платформе можно удалять в корзину (с возможностью восстановления), удалять сразу без возможности восстановления.

## Удаление ресурса
Для удаления ресурса применяется команда:
```bash
terraform destroy
```
После выполнения данной команды произойдет следующее:
- Будет удален файл состояния ресурса .tfstate
- Ресурс не удалится с платформы, а будет помещен в корзину, с возможностью восстановления


## Восстановление ресурсов
__Ресурс можно восстановить, если у него есть поле `restore`__, в противном случае, необходимо воспользоваться порталом для восстановления.
После удаления ресурса, он помечается как "Deleted" и его можно восстановить.  
Для восстановления ресурса необходимо выполнить следующие действия:
- Создать файл .tf и описать в нем восстанавливаемый ресурс
- Импортировать ресурс
- Добавить поле restore со значением `true`
- Выполнить `terraform apply`

## Удаление ресурсов без возможности восстановления
Ресурсы можно удалять с платформы сразу, минуя корзину. Однако, такое удаление возможно только для ресурсов, имеющих поле `permanently`.
Для этого необходимо выполнить сл. шаги:
- В файле .tf добавить поле `permanently = true`
- Применить изменения `terraform apply`
- Выполнить удаление `terraform destroy`

**Проводя мгновенное удаление, ресурс восстановить будет невозможно!**
