Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функции **decort_cb_grid_get_status**, **decort_cb_grid_post_status** служат для получения статуса активности текущей среды grid. Grid это пространства, на которых возможно размещение виртуальных машин.

## Аргументы

_Data source_ функции **decort_cb_grid_get_status**, **decort_cb_grid_post_status** не принимают входящих параметров.

## Возвращаемые значения

В случае успешного выполнения _data source_ функции **decort_cb_grid_get_status**, **decort_cb_grid_post_status** возвращают в указанную при вызове переменную, содержащую следующие параметры:

| Параметр | Тип | Описание |
| --- | --- | --- |
| status | bool | Статус активности текущей среды |

## Пример использования

Пример вызова _data source_ функций **decort_cb_grid_get_status**, **decort_cb_grid_post_status**:

```terraform
data "decort_cb_grid_get_status" "gs" {
  #нет входящих параметров
}

data "decort_cb_grid_post_status" "ps" {
  #нет входящих параметров
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.1/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_cb_grid_get_status** или **decort_cb_grid_post_status** в переменной `data.decort_cb_grid_get_status.gs` или `data.decort_cb_grid_post_status.ps`, соответственно, будут сохранены возвращаемые значения.
