Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_vins_audits** служит для получения записей аудита для внутренней сети vins.

## Аргументы
_Data source_ функция **decort_cb_vins_audits** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| vins_id | int | :heavy_check_mark: | ID внутренней сети |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_vins_audits** возвращает в указанную при вызове переменную, которая состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| call | string | Вызов |
| response_time | float | Время ответа |
| status_code | int | Статус выполнения |
| time_stamp | float | Время выполнения |
| user | string | Имя пользователя |

## Пример использования
Пример вызова _data source_ функции **decort_cb_vins_audits**:
```terraform
data "decort_cb_vins_audits" "audits" {
  #id желаемого vins
  #обязательный параметр
  #тип - целое число
  vins_id = 10101
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.1/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_cb_vins_audits** в переменной `data.decort_cb_vins_audits.audits` будут сохранены возвращаемые значения.
