Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_rg_affinity_group_computes** служит для получения информации о компьютах аффинити группы.

Ресурсная группа в облачной платформе DECORT это способ группирования _compute_-ов (например, по функциональному признаку или принадлежности к одному и тому же проекту). Ресурсную группу можно рассматривать как небольшой персональный дата-центр, в котором размещаются один или несколько серверов и виртуальных сетевых сегментов (ViNS).

Экземпляры _compute_ (виртуальные серверы) всегда создаются в принадлежности к какой-либо ресурсной группе. Как следствие, для создания экземпляра _compute_ помимо других параметров требуется указать идентификатор целевой ресурсной группы. Для получения такого идентификатора можно воспользоваться рассматриваемой здесь _data source_ функцией **decort_cb_rg_affinity_group_computes**.

## Аргументы
_Data source_ функция **decort_cb_rg_affinity_group_computes** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| rg_id | :heavy_check_mark: | int | Идентификатор ресурсной группы |
| affinity_group | :heavy_check_mark: | string | Аффинити группа |

Пользователь облачной платформы, от лица которого происходит обращение к данной функции, должен иметь доступ к указанному `account` и ресурсной группе. В противном случае возникнет ошибка доступа.

Пользователь облачной платформы задается на стадии инициализации Terraform провайдера DECORT (см. [подробности](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.1/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_rg_affinity_group_computes** возвращает в указанную при вызове переменную, в поле _items_, массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| compute_id | int | Идентификатор компьюта |
| other_node | []int | Спсиок other node |
| other_node_indirect | []int | Список other node indirect |
| other_node_indirect_soft | []int | Список other node indirect soft |
| other_node_soft | []int | Список other node soft |
| same_node | []int | Список same node |
| same_node_soft | []int | Список same node soft |

## Пример использования
Пример вызова _data source_ функции **decort_cb_rg_affinity_group_computes**:

```terraform
data "decort_cb_rg_affinity_group_computes" "rg_affinity_group_computes" { 
  #id ресурсной группы
  #обязательный параметр
  #тип - целое число
  rg_id = 123

  #название специальной группы компьютов
  #обязательное поле
  #тип - строка
  affinity_group = "TEST"
}
# Once the above directive completes, resource group affinity group computes will be accessible as
# data.decort_cb_rg_affinity_group_computes.rg_affinity_group_computes.items
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.1/04.02-Инициализация-Terraform-провайдера-DECORT.md) и [пример](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.1/02.-Пример-работы.md)). 

После успешного завершения такого вызова **decort_cb_rg_affinity_group_computes** в переменной `data.decort_cb_rg_affinity_group_computes.rg_affinity_group_computes.items` будут сохранены возвращаемые значения.
