Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_extnet_static_route** служит для получения статического маршрута для внешней сети.

## Аргументы
_Data source_ функция **decort_cb_extnet_static_route** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| extnet_id | int | :heavy_check_mark: | ID внешней сети |
| route_id | int | :heavy_check_mark: | ID статического маршрута |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_extnet_static_route** возвращает в указанную при вызове переменную, которая состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| compute_ids | []int | Список ID compute, которым предоствавлен доступ |
| destination | string | IP целевой сети |
| gateway | string | IP шлюза |
| guid | string | ID ресурса |
| route_id | int | ID статического маршрута |
| netmask | string | Маска сети |
| extnet_id | int | ID внешней сети |

## Пример использования
Пример вызова _data source_ функции **decort_cb_extnet_static_route**:
```terraform
data "decort_cb_extnet_static_route" "route" {
  #обязательный параметр
  #id extnet в котором добавлены routes
  #тип - целое число
  extnet_id = 1111

  #обязательный параметр
  #id route 
  #тип - целое число
  route_id = 1
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.1/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_cb_extnet_static_route** в переменной `data.decort_cb_extnet_static_route.sr` будут сохранены возвращаемые значения.
