Функция доступна в провайдере версии 2.3 и выше.

_Data source_ функция **decort_account_vins_list** служит для получения информации об используемых аккаунтом сетях.

## Аргументы
_Data source_ функция **decort_account_vins_list** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| account_id | int | :heavy_check_mark: | ID аккаунта |
| vins_ id | int | :x: | Фильтр по ID ViNS |
| name | string | :x: | Фильтр по имени ViNS |
| rg_id | int | :x: | Фильтр по ID рес. группы |
| ext_ip | string | :x: | Фильтр по внешнему IP |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |
| page | int | :x: | Номер страницы |
| size | int | :x: | Размер страницы |


## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_account_vins_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | ID аккаунта - владельца виртуальной сети |
| account_name | string | Имя аккаунта - владельца виртуальной сети |
| computes | int | Кол-во вычислительных мощностей, использующих виртуальную сеть |
| created_by | string | Информация о создателе виртуальной сети |
| created_time | int | Время создания виртуальной сети |
| deleted_by | string | Информация о том, кто удалил виртуальную сеть |
| deleted_time | int | Время удаления виртуальной сети |
| external_ip | string | Внешний IP - адрес |
| extnet_id | int | Идентификатор внешней сети |
| free_ips | int | Количество свободных IP - адресов сети |
| vin_id | int | Идентификатор виртуальной сети |
| vin_name | string | Название виртуальной сети |
| network | string | Сеть |
| pri_vnf_dev_id | int | ID для vnf - разработки |
| rg_id | int | ID ресурсной группы |
| rg_name | string | Название ресурсной группы |
| status | string | Статус ресурсной группы |
| updated_by | string | Кем была обновлена ресурсная группа |
| updated_time | int | Время обновления |


## Пример использования
Пример вызова _data source_ функции **decort_account_vins_list**:
```terraform
data "decort_account_vins_list" "avl" {
  #id аккаунта
  #обязательный параметр
  #тип - целое число
  account_id = 22222

  #фильтр по id vins
  #опциональный параметр
  #тип - целое число
  #vins_id = 100

  #фильтр по имени vins
  #опциональный параметр
  #тип - строка
  #name = "test"

  #фильтр по id ресурсной группы
  #опциональный параметр 
  #тип - целое число
  #rg_id = 11111

  #фильтр по IP внешней сети
  #опциональный параметр
  #тип - строка
  #ext_ip = "test"

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #тип - строка
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #sort_by = "+name"

  #номер страницы для отображения
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #page = 2

  #размер страницы
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #size = 3
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.2/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_account_vins_list** в переменной `data.decort_account_vins_list.avl` будут сохранены возвращаемые значения.
