Функция доступна в провайдере версии 4.7.0 и выше.

_Data source_ функция **decort_dpdknet_list** служит для получения информации об имеющихся DPDK сетях.

## Аргументы
_Data source_ функция **decort_dpdknet_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| by_id | int | :x: | Фильтр по ID DPDK сети |
| gid | int | :x: | Фильтр по GRID ID |
| name | string | :x: | Фильтр по имени сети |
| desc | string | :x: | Фильтр по описанию сети |
| status | string | :x: | Фильтр по статусу |
| compute_ids | []int | :x:  Фильтр по compute IDs |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |
| page | int | :x: | Номер страниц |
| size | int | :x: | Размер страницы |


## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_dpdknet_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_access | []int | Cписок ID аккаунтов, которым может быть выделена сеть в эксклюзивное пользование |
| compute_ids | []int | Cписок компьютов, которые используют данную сеть для своих интерфейсов |
| created_time | int | Время создания |
| desc | string | Текстовое описание сети |
| dpdk_id | int | Идентификатор сети |
| gid | int | Идентификатор площадки (GRID ID) |
| guid | int | GUID ресурса |
| id | string | Идентификатор запроса |
| name | string | Наименование сети |
| ovs_bridge | string | OVS bridge в котором будут создаваться интерфейсы для компьютов, созданные из этой сети |
| rg_access | []int | Cписок ID ресурсных групп, которым может быть выделена сеть в эксклюзивное пользование |
| status | string | Статус сети |
| updated_time | int | Время обновления |
| vlan_id | int | ID виртуальной сети для тегирования траффика на интерфейсе для компьюта |

## Пример использования
Пример вызова _data source_ функции **decort_dpdknet_list**:
```terraform
data "decort_dpdknet_list" "dl" {
  #фильтр по ID DPDK сети
  #опциональный параметр
  #тип - целое число
  #by_id = 100

  #фильтр по GRID ID
  #опциональный параметр
  #тип - целое число
  #gid = 100
 
  #фильтр по имени сети
  #опциональный параметр
  #тип - строка
  #name = "test_dpdk"

  #фильтр по описания
  #опциональный параметр
  #тип - строка
  #desc = "user"

  #фильтр по статусу
  #опциональный параметр
  #тип - строка
  #status = "ENABLED"

  #фильтр по compute IDs
  #опциональный параметр
  #тип - массив чисел
  #compute_ids = [11111,22222]

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #тип - строка
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #sort_by = "+name"

  #кол-во страниц для вывода
  #опциональный параметр
  #тип - целое число
  #page = 1

  #размер страницы
  #опциональный параметр
  #тип - целое число
  #size = 1
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.2/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_dpdknet_list** в переменной `data.decort_dpdknet_list.dl` будут сохранены возвращаемые значения.
