Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_kvmvm_snapshot_list** служит для получения информации о использовании снапшотов.

Ресурсная группа в облачной платформе DECORT это способ группирования _compute_-ов (например, по функциональному признаку или принадлежности к одному и тому же проекту). Ресурсную группу можно рассматривать как небольшой персональный дата-центр, в котором размещаются один или несколько серверов и виртуальных сетевых сегментов (ViNS).

## Аргументы
_Data source_ функция **decort_cb_kvmvm_snapshot_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| compute_id | int | :heavy_check_mark: | Идентификатор компьюта |

Пользователь облачной платформы задается на стадии инициализации Terraform провайдера DECORT (см. [подробности](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.2/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_kvmvm_snapshot_list** возвращает в указанную при вызове переменную, в поле _items_, массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| disks | []int | Список id дисков |
| guid | string | ID ресурса |
| label | string | Название снапшота |
| timestamp | int | Время снапшота |

## Пример использования
Пример вызова _data source_ функции **decort_cb_kvmvm_snapshot_list**:

```terraform
data "decort_cb_kvmvm_snapshot_list" "snapshot_list" {
  #id виртуальной машины
  #обязательный параметр
  #тип - целое число
  compute_id = 1234
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.2/04.02-Инициализация-Terraform-провайдера-DECORT.md) и [пример](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.2/02.-Пример-работы.md)). 

После успешного завершения такого вызова **decort_cb_kvmvm_snapshot_list** в переменной `data.decort_cb_kvmvm_snapshot_list.snapshot_list.items` будут сохранены возвращаемые значения.
