Функция доступна в провайдере версии 2.3 и выше.

_Data source_ функция **decort_account_flipgroups_list** служит для получения информации об используемых групп с плавающим ip-адресом.

## Аргументы
_Data source_ функция **decort_account_flipgroups_list** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| account_id | int | :heavy_check_mark: | ID аккаунта |
| name | string | :x: | Фильтр по имени флипгруппы |
| flipgroup_id | int | :x: | Фильтр по ID флипгруппы |
| vins_id | int | :x: | Фильтр по ID ViNS |
| vins_name | string | :x: | Фильтр по имени ViNS |
| extnet_id | int | :x: | Фильтр по ID extnet |
| by_ip | string | :x: | Фильтр по IP адресу |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |
| page | int | :x: | Номер страницы |
| size | int | :x: | Размер страницы |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_account_flipgroups_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | ID аккаунта - владельца группы с плавающим ip-адресом |
| client_type | string | Тип клиента |
| conn_type | string | Тип соединения |
| created_by | string | Информация о создателе группы с плавающим ip-адресом |
| created_time | int | Время создания группы с плавающим ip-адресом |
| default_gw | string | Gateway группы с плавающим ip-адресом по-умолчанию |
| deleted_by | string | Информация о том, кто удалил группу с плавающим ip-адресом |
| deleted_time | int | Время удаления группы с плавающим ip-адресом |
| desc | string | Описание группы с плавающим ip-адресом |
| gid | int | Grid id |
| guid | int | Внутренний идентификатор группы с плавающим ip-адресом |
| fg_id | int | ID группы с плавающим ip-адресом |
| ip | string | IP-адрес |
| milestones | int | Вехи |
| fg_name | string | Название группы с плавающим ip-адресом |
| net_id | int | ID сети |
| net_type | string | Тип сети |
| netmask | int | Маска сети |
| status | string | Статус группы с плавающим ip-адресом |
| updated_by | string | Кем группа с плавающим ip-адресом была обновлена в последний раз |
| updated_time | int | Время последнего обновления |

## Пример использования
Пример вызова _data source_ функции **decort_account_flipgroups_list**:
```terraform
data "decort_account_flipgroups_list" "afgl" {
  #id аккаунта
  #обязательный параметр
  #тип - целое число
  account_id = 1111

  #фильтр по имени flipgroup
  #опциональный параметр
  #тип - строка
  #name = "test"

  #фильтр по id vins
  #опциональный параметр
  #тип - целое число
  #vins_id = 100

  #фильтр по имени vins
  #опциональный параметр
  #тип - строка
  #vins_name = "test"

  #фильтр по id extnet
  #опциональный параметр
  #тип - целое число
  #extnet_id = 100

  #фильтр по IP
  #опциональный параметр
  #тип - строка
  #by_ip = "1.1.1.1.1"

  #фильтр по id flipgroup
  #опциональный параметр
  #тип - целое число
  #flipgroup_id = 100

  #кол-во страниц для вывода
  #опциональный параметр
  #тип - целое число
  #page = 1

  #размер страницы
  #опциональный параметр
  #тип - целое число
  #size = 1
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.3/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_account_flipgroups_list** в переменной `data.decort_account_flipgroups_list.afgl` будут сохранены возвращаемые значения.
