Функция доступна в провайдере версии 2.3 и выше.

_Data source_ функция **decort_bservice_list** служит для получения информации о всех доступных базовых сервисах. Базовый сервис (basic service) может быть шаблоном, на основе которого создаются вычислительные мощности (computes).

## Аргументы
_Data source_ функция **decort_bservice_list** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| by_id | int | :x: | Фильтр по ID |
| name | string | :x: | Фильтр по имени |
| rg_name | string | :x: | Фильтр по имени ресурсной группы |
| tech_status | string | :x: | Фильтр по тех. статусу |
| status | string | :x: | Фильтр по статусу |
| account_name | string | :x: | Фильтр по имени аккаунта |
| account_id | int | :x: | ID аккаунта для фильтрации результата |
| rg_id | int | :x: | ID ресурсной группы для фильтрации результата |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |
| page | int | :x: | Номер страниц |
| size | int | :x: | Размер страницы |


## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_bservice_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | ID аккаунта |
| account_name | string | Название аккаунта |
| base_domain | string | Базовый домен |
| created_by | string | Кем создан сервис |
| created_time | int | Время создания сервиса |
| deleted_by | string | Кем удален сервис |
| deleted_time | int | Время удаления сервиса |
| gid | int | Grid id |
| groups | []int | Список вычислительных групп сервиса |
| guid | int | Внутренний ID сервиса |
| service_id | int | ID сервиса |
| service_name | string | Название сервиса |
| parent_srv_id | int | ID родительского сервисе |
| parent_srv_name | string | Название родительского сервиса |
| rg_id | int | ID ресурсной группы |
| rg_name | string | Название ресурсной группы |
| ssh_user | string | Имя пользователя для подключения по ssh |
| status | string | Статус сервиса |
| tech_status | string | Технический статус сервиса |
| updated_by | string | Кем сервис был обновлен |
| updated_time | int | Время последнего обновления |
| user_managed | bool | Флаг, управляется ли пользователем |

## Пример использования
Пример вызова _data source_ функции **decort_bservice_list**:
```terraform
data "decort_bservice_list" "bsl" {
  #фильтр по id базового сервиса
  #опциональный параметр
  #тип - целое число
  #by_id = 100

  #фильтр по имени базового сервиса
  #опциональный параметр
  #тип - строка
  #name = "test"

  #id аккаунта для фильтрации данных
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #account_id = 11111

  #фильтр по имени ресурсной группы
  #опциональный параметр
  #тип - строка
  #rg_name = "test"

  #id ресурсной группы, используется для фильтрации
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #rg_id = 11111

  #фильтр по техническому статусу
  #опциональный параметр
  #тип - строка
  #tech_status = "STARTED"

  #фильтр по статусу
  #опциональный параметр
  #тип - строка
  #status = "ENABLED"

  #фильтр по имени аккаунта
  #опциональный параметр
  #тип - строка
  #account_name = "test"

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #тип - строка
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #sort_by = "+name"

  #номер страницы для отображения
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #page = 2

  #размер страницы
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #size = 3
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.4/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_bservice_list** в переменной `data.decort_bservice_list.bsl` будут сохранены возвращаемые значения.
