Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_k8ci_list** служит для получения информации о доступных k8ci (конфигурация Кластера Kubernetes).

## Аргументы

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| by_id | int | :x: | Фильтр по ID k8ci |
| name | string | :x: | Фильтр по имени k8ci |
| status | string | :x: | Фильтр по статусу |
| worker_driver | string | :x: | Фильтр по драйверу worker |
| master_driver | string | :x: | Фильтр по драйверу master |
| network_plugin | string | :x: | Фильтр по плагину сети (flannel, calico или weavenet) |
| include_disabled | bool | :x: | Дополнить рез-тат выключенными k8ci |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |
| page | int | :x: | Номер страницы |
| size | int | :x: | Размер страницы |

## Возвращаемые значения (в списке items)

| Параметр | Тип | Описание |
| --- | --- | --- |
| created_time | int | Время создания |
| desc | string | Описание |
| gid | int | Grid ID |
| guid | int | ID ресурса |
| k8ci_id | int | ID k8ci |
| lb_image_id | int | ID образа балансировщика |
| master_driver | string | Драйвер master-узла |
| master_image_id | int | ID образа master-узла k8ci |
| max_master_count | int | Ограничение политики на максимальное количество master-узлов |
| max_worker_count | int | Ограничение политики на максимальное количество worker-узлов |
| name | string | Наименование k8ci |
| shared_with | []int | Список ресурсов, имеющих доступ к k8ci |
| status | string | Статус k8ci |
| version | string | Версия |
| worker_driver | string | Драйвер worker-узла |
| worker_image_id | int | ID образа worker-узла k8ci |

## Пример использования

```terraform
data "decort_cb_k8ci_list" "k8ci_list" {
  #фильтр по id k8ci
  #опциональный параметр
  #тип - целое число
  #by_id = 111

  #фильтр по имени k8ci
  #опциональный параметр
  #тип - строка
  #name = "name"

  #фильтр по статусу k8ci
  #опциональный параметр
  #тип - строка
  #status = "status"

  #фильтр по worker driver
  #опциональный параметр
  #тип - строка
  #worker_driver = "KVM_X86"

  #фильтр по master driver
  #опциональный параметр
  #тип - строка
  #master_driver = "KVM_X86"

  #фильтр по network plugin
  #опциональный параметр
  #тип - строка
  #network_plugin = "flannel"

  #исключить из результата недоступные k8ci
  #опциональный параметр
  #тип - булев
  #include_disabled = "true"

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #тип - строка
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #sort_by = "+name"

  #номер страницы для отображения
  #опциональный параметр
  #тип - целое число
  #page = 2

  #размер страницы
  #опциональный параметр
  #тип - целое число
  #size = 3
}
```

После успешного завершения такого вызова **decort_cb_k8ci_list** в переменной `data.decort_cb_k8ci_list.k8ci_list.items` будут сохранены возвращаемые значения.
