Функция доступна в провайдере версии 2.3 и выше.

_Data source_ функция **decort_account_rg_list** служит для получения информации о ресурсных группах, принадлежащих аккаунту.

## Аргументы
_Data source_ функция **decort_account_rg_list** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| account_id | int | :heavy_check_mark: | ID аккаунта |
| rg_id | int | :x: | Фильтр по ID рес. группы |
| vins_id | int | :x: | Фильтр по ID ViNS |
| vm_id | int | :x: | Фильтр по ID вирт. машины |
| name | string | :x: | Фильтр по имени рес. группы |
| status | string | :x: | Фильтр по статусу |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |
| page | int | :x: | Номер страницы |
| size | int | :x: | Размер страницы |


## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_account_rg_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| computes | Struct{<br/>started int<br/>stopped int <br/>} | Информация о вычислительных мощностях<br/>Кол-во запущенных<br/>Кол-во остановленных<br/>&nbsp;<br/> |
| resources | Struct{<br/>consumed Struct{<br/>cpu int<br/>disksize int<br/>extips int<br/>exttraffic int<br/>gpu int<br/>ram int<br/>}<br/>limits Struct{<br/>cpu int<br/>disksize int<br/>extips int<br/>exttraffic int<br/>gpu int<br/>ram int<br/>}<br/>reserved Struct{<br/>cpu int<br/>disksize int<br/>extips int<br/>exttraffic int<br/>gpu int<br/>ram int<br/>}<br/>} | Информация о ресурсах<br/>Задействованные<br/>Кол-вол ядер<br/>Размер диска, ГБ<br/>Кол-во внешних ip-адресов<br/>Размер внешнего траффика<br/>Кол-во графических ядер<br/>Размер RAM, МБ<br/><br/>Максимально возможные значения<br/> Кол-вол ядер<br/>Размер диска, ГБ<br/>Кол-во внешних ip-адресов<br/>Размер внешнего траффика<br/>Кол-во графических ядер<br/>Размер RAM, МБ<br/><br/>Зарезервированные<br/>Кол-вол ядер<br/>Размер диска, ГБ<br/>Кол-во внешних ip-адресов<br/>Размер внешнего траффика<br/>Кол-во графических ядер<br/>Размер RAM, МБ<br/><br/>&nbsp;<br/> |
| created_by | string | Информация о создателе группы |
| created_time | int | Время создания группы |
| deleted_by | string | Информация о том, кто удалил группу |
| deleted_time | int | Время удаления группы |
| rg_id | int | Идентификатор ресурсной группы |
| rg_name | string | Название ресурсной группы |
| milestones | int | Вехи |
| status | string | Статус группы |
| updated_by | string | Кем группа была обновлена в последний раз |
| updated_time | int | Время последнего обновления |
| vinses | int | Количество виртуальных сетей |

## Пример использования
Пример вызова _data source_ функции **decort_account_rg_list**:
```terraform
data "decort_account_rg_list" "argl" {
  #id аккаунта
  #обязательный параметр
  #тип - целое число
  account_id = 66666

  #номер страницы для отображения
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #page = 2

  #размер страницы
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #size = 3

  #фильтр по id ресурсной группы
  #опциональный параметр 
  #тип - целое число
  #rg_id = 11111

  #фильтр по имени ресурсной группы
  #опциональный параметр
  #тип - строка
  #name = "test"

  #фильтр по id vins
  #опциональный параметр
  #тип - целое число
  #vins_id = 100

  #фильтр по id compute
  #опциональный параметр
  #тип - целое число
  #vm_id = 100

  #фильтр по статусу
  #опциональный параметр
  #тип - строка
  #status = "CREATED"

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #тип - строка
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #sort_by = "+name"
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.8.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_account_rg_list** в переменной `data.decort_account_rg_list.argl` будут сохранены возвращаемые значения.
