Функция доступна в провайдере версии 4.7.0 и выше.

_Data source_ функция **decort_cb_grid_get_settings** служит для получения настроек grid. Grid это пространства, на которых возможно размещение виртуальных машин. 

## Аргументы
_Data source_ функция **decort_cb_grid_get_settings** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| grid_id | int | :heavy_check_mark: | ID grid |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_grid_get_settings** возвращает в указанную при вызове переменную, которая состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| grid_id | int | ID grid |
| allowed_ports | []int | Список разрешенных портов для подключения |
| cleanup_retention_period | int | Период хранения данных |
| docker_registry | Struct{} [см. ниже](#Описание-структуры-docker_registry) | Настройки для подключения к docker registry |
| enable_uptime_monitor | bool | Флаг мониторинга доступности |
| extnet_max_pre_reservations_num | int | Кол-во зарезервированных ip адресов для внешних сетей |
| healthcheck_notifications | Struct{} [см. ниже](#Описание-структуры-healthcheck_notifications) | Настройки уведомлений healthcheck |
| id | int | ID запроса |
| k8s_cleanup_enabled | bool | Флаг автоматической очистки k8s |
| limits | string | Лимиты |
| location_url | string | URL платформы |
| net_qos | Struct{} [см. ниже](#Описание-структуры-net_qos) | Настройки QoS |
| networks | string | Наименования сетей |
| prometheus | Struct{} [см. ниже](#Описание-структуры-prometheus) | Настройки prometheus |
| vins_max_pre_reservations_num | int | Кол-во зарезервированных ip адресов для виртуальных сетей  |
| vnfdev_mgmt_net_range | string | Диапазон IP-адресов для управления устройствами VNF |

### Описание структуры docker_registry
| Параметр | Тип | Описание |
| --- | --- | --- |
| password | string | Пароль |
| server | string | URL сервера |
| username | string | Имя пользователя |

### Описание структуры healthcheck_notifications
| Параметр | Тип | Описание |
| --- | --- | --- |
| emails | []Struct{} [см. ниже](#Описание-структуры-emails) | Список email для уведомлений |

### Описание структуры emails
| Параметр | Тип | Описание |
| --- | --- | --- |
| address | string | email |
| enabled | bool | флаг доступности |

### Описание структуры net_qos
| Параметр | Тип | Описание |
| --- | --- | --- |
| extnet | Struct{} [см. ниже](#Описание-структуры-qos_settings) | Настройки QoS для внешних сетей |
| vins | Struct{} [см. ниже](#Описание-структуры-qos_settings) | Настройки QoS для виртуальных сетей |

### Описание структуры qos_settings
| Параметр | Тип | Описание |
| --- | --- | --- |
| e_rate | string | Скорость исходящего трафика |
| in_burst | string | Размер буфера входящего трафика |
| in_rate | string | Скорость входящего трафика |

### Описание структуры prometheus
| Параметр | Тип | Описание |
| --- | --- | --- |
| scrape_interval | int | Интервал сбора метрик |

## Пример использования
Пример вызова _data source_ функции **decort_cb_grid_get_settings**:
```terraform
data "decort_cb_grid_get_settings" "gs" {
  #id grid для получения информации
  #обязательный параметр 
  #тип - целое число
  grid_id = 215
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.8.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_cb_grid_get_settings** в переменной `data.decort_cb_grid_get_settings.gs` будут сохранены возвращаемые значения.
