Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_vgpu** служит для получения информации об имеющимся виртуальном графическом устройстве.

## Аргументы
_Data source_ функция **decort_vgpu** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| vgpu_id | int | :heavy_check_mark: | ID устройства |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_pcidevice** возвращает в указанную при вызове переменную элемент, который состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| vgpu_id | int | id устройства |
| account_id | int | id аккаунта, к которому привязано устройство |
| mode | string | Режим работы устройства |
| pgpu | int | id физического устройства, на основе которого создано виртуальное |
| profile_id | int | id профиля, к которому привязано устройство |
| ram | int | Количество ОЗУ виртуального устройства |
| status | string | Статус устройства |
| type | string | Тип устройства |
| vm_id | int | id виртуальной машины, использующей устройство |


## Пример использования
Пример вызова _data source_ функции **decort_vgpu**:
```terraform
data "decort_vgpu" "vgpu" {
  #id vgpu
  #обязательный параметр
  #тип - целое число
  vgpu_id = 1111

}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.8.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_vgpu** в переменной `data.decort_vgpu.vgpu` будут сохранены возвращаемые значения.
