Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_k8ci** служит для получения информации о k8ci (конфигурация Кластера Kubernetes).

## Аргументы

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| k8ci_id | int | :heavy_check_mark: | ID k8ci |

## Возвращаемые значения

| Параметр | Тип | Описание |
| --- | --- | --- |
| desc | string | Описание |
| gid | int | Grid ID |
| guid | int | ID ресурса |
| k8ci_id | int | ID k8ci |
| lb_image_id | int | ID образа балансировщика |
| master_driver | string | Драйвер master-узла |
| master_image_id | int | ID образа master-узла k8ci |
| max_master_count | int | Ограничение политики на максимальное количество master-узлов |
| max_worker_count | int | Ограничение политики на максимальное количество worker-узлов |
| milestones | int | Вехи |
| name | string | Наименование k8ci |
| network_plugins | []string | Список доступных плагинов сети |
| shared_with | []int | Список ресурсов, имеющих доступ к k8ci |
| status | string | Статус k8ci |
| version | string | Версия |
| worker_driver | string | Драйвер worker-узла |
| worker_image_id | int | ID образа worker-узла k8ci |

## Пример использования

```terraform
data "decort_cb_k8ci" "k8ci" {
  #id k8ci
  #обязательный параметр
  #тип - целое число
  k8ci_id = 111
}
```

После успешного завершения такого вызова **decort_cb_k8ci** в переменной `data.decort_cb_k8ci.k8ci` будут сохранены возвращаемые значения.
