Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_pcidevice** служит для получения информации об имеющихся устройств с шиной PCI.

## Аргументы
_Data source_ функция **decort_cb_pcidevice** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| device_id | int | :heavy_check_mark: | ID устройства |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_pcidevice** возвращает в указанную при вызове переменную элемент, который состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| ckey | string | CKey |
| meta | []string | Мета информация |
| compute_id | int | id вычислительной площадки |
| description | string | Описание |
| guid | int | Внутренний id |
| hw_path | string | HW Путь |
| device_id | int | id устройства |
| name | string | Наименование устройства |
| rg_id | int | id ресурсной группы (resource group) |
| stack_id | int | id стэка |
| status | string | Статус устройства |
| system_name | string | Системное имя устройства |


## Пример использования
Пример вызова _data source_ функции **decort_cb_pcidevice**:
```terraform
data "decort_cb_pcidevice" "pd" {
  #id устройства
  #обязательный параметр
  #тип - целое число
  device_id = 111
}
# once the above directive completes, pcidevice will be accessible 
# as data.decort_cb_pcidevice.pd
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.8.1/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_cb_pcidevice** в переменной `data.decort_cb_pcidevice.pd` будут сохранены возвращаемые значения.
