Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_sep_list** служит для получения информации обо всех доступных пользователю storage endpoints. Storage endpoint (sep) - точка доступа к хранилищу данных. Sep бывает четырех типов:

- des
- hitachi
- dorado
- tatlin

Каждый тип отличается возможной конфигурацией.

## Аргументы

_Data source_ функция **decort_cb_sep_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| by_id | int | :x: | Фильтр по id sep |
| name | string | :x: | Фильтр по названию sep |
| gid | int | :x: | Фильтр по grid id |
| type | string | :x: | Фильтр по типу sep |
| provided_by | int | :x: | Фильтр по ID физического узла (provided) для выборки |
| tech_status | string | :x: | Фильтр по техническому статусу |
| consumed_by | int | :x: | Фильтр по ID физического узла (consumed) для выборки |
| page | int | :x: | Номер страницы для вывода |
| size | int | :x: | Размер страницы для вывода |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_cb_sep_list** возвращает в указанную при вызове переменную, в поле _items_, массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| sep_id | int | id storage endpoint |
| config | json string | Конфигурация sep |
| consumed_by | []int | Список node id, использующих sep |
| desc | string | Описание sep |
| gid | int | Grid id, к которому привязан sep |
| guid | int | Внутренний id sep |
| milestones | int | Вехи |
| name | string | Наименование sep |
| multipath_num | int | Количество устройств, перечисленных с помощью multipath |
| obj_status | string | Статус sep |
| provided_by | []int | Список provider id, использующих sep |
| shared_with | []int | Список id учетных записей, у которых есть доступ к sep |
| tech_status | string | Технический статус sep |
| type | string | Тип sep |

## Пример использования

Пример вызова _data source_ функции **decort_cb_sep_list**:

```terraform
data "decort_cb_sep_list" "sl" {
  #фильтр по sep id
  #необязательный параметр
  #тип - целое число
  #by_id = 3

  #фильтр по sep name
  #необязательный параметр
  #тип - строка
  #name = "name"

  #фильтр по gid
  #необязательный параметр
  #тип - целое число
  #gid = 1

  #фильтр по sep type
  #необязательный параметр
  #тип - строка
  #type = "type"

  #фильтр по provided physical node id
  #необязательный параметр
  #тип - целое число
  #provided_by = 1

  #фильтр по тех статусу
  #необязательный параметр
  #тип - строка
  #tech_status = "status"

  #фильтр по consumed physical node id
  #необязательный параметр
  #тип - целое число
  #consumed_by = 1

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #тип - строка
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #sort_by = "+name"

  #страница
  #необязательный параметр
  #тип - целое число
  #page = 3

  #размер страницы
  #необязательный параметр
  #тип - целое число
  #size = 2
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.8.1/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_cb_sep_list** в переменной `data.decort_cb_sep_list.sl.items` будут сохранены возвращаемые значения.
