Функция доступна в провайдере версии 3.2 и выше.

_Data source_ функция **decort_disk_snapshot** служит для получения информации о снимке состояния диска.

## Аргументы
_Data source_ функция **decort_disk_snapshot** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| disk_id | int | :heavy_check_mark: | ID диска, снимок которого необходимо получить |
| label | string | :heavy_check_mark: | ID снимка |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_disk_snapshot** возвращает в указанную при вызове переменную следующие параметры:

| Параметр | Тип | Описание |
| --- | --- | --- |
| disk_id | int | ID диска, снимок которого необходимо получить |
| label | string | ID снимка |
| timestamp | int | Время снимка |
| res_id | string | Ссылка на снимок |
| snap_set_guid | string | ID набора снимков, в котором лежит снимок состояния |
| snap_set_time | string | Время набора |

## Пример использования
Пример вызова _data source_ функции **decort_disk_snapshot**:
```terraform
data "decort_disk_snapshot" "ds" {
  #Номер диска
  #обязательный параметр
  #тип - целое число
  disk_id = 20100

  #Ярлык диска
  #обязательный параметр
  #тип - строка
  label = "label"
}
```

После успешного завершения такого вызова **decort_disk_snapshot** в переменной `data.decort_disk_snapshot.ds` будут сохранены возвращаемые значения.
