Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_k8s_computes** служит для получения информации о виртуальных машинах кластера

## Аргументы

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| k8s_id | int | :heavy_check_mark: | ID кластера |

## Возвращаемые значения

| Параметр | Тип | Описание |
| --- | --- | --- |
| masters | []Struct{} [см. ниже](#описание-структуры-masters) | Список мастер ВМ (см. ниже) |
| workers | []Struct{} [см. ниже](#описание-структуры-workers) | Список воркер ВМ (см.ниже) |

## Описание структуры masters

| Параметр | Тип | Описание |
| --- | --- | --- |
| id | int | ID виртуальной машины |
| name | string | Наименование виртуальной машины |
| group_name | string | Наименование мастер-группы, к которой принадлежит ВМ |
| status | string | Статус ВМ |
| tech_status | string | Тех. статус ВМ |

## Описание структуры workers

| Параметр | Тип | Описание |
| --- | --- | --- |
| id | int | ID виртуальной машины |
| name | string | Наименование виртуальной машины |
| group_name | string | Наименование воркер-группы, к которой принадлежит ВМ |
| status | string | Статус ВМ |
| tech_status | string | Тех. статус ВМ |

## Пример использования

```terraform
data "decort_cb_k8s_computes" "computes" {
  #id кластера
  #обязательный параметр
  #тип - целое число
  k8s_id = 1234
}
```

После успешного завершения такого вызова **decort_cb_k8s_computes** в переменной `data.decort_cb_k8s_computes.computes` будут сохранены возвращаемые значения.
