# Установка Terraform
На момент написания инструкции, приложение Terraform по прямой ссылке с сайта-разработчика программного обеспечения невозможно скачать, по этой же причине, невозможно произвести установку с помощью разных пакетных менеджеров.
Существует два способа произвести установку приложения:
- Скачать скомпилированное приложение с зеркала компании Digital Energy.
- Из исходных кодов.
## Скачивание и установка скомпилированного приложения с зеркала компании Digital Energy
1. Перейти по ссылке https://colba.decs.online/index.php/s/JfkXWbwTqww64Tz , выбрать версию terraform для подходящей ОС.
2. Скачать архив.
3. Разархивировать приложение и переместить:
- Для Linux или MacOS:  `/usr/local/bin`
- Для Windows:  в любую папку, после чего добавить в $PATH в переменных окружения путь до приложения
4. Ввести в терминале `terraform -help`, в случае успеха, на экран будет информация о программе.
### Указание переменных среды окружения в Windows
Меню -> Панель управления -> Система -> Настройки -> Переменные окружения  
Или  
Поиск -> Изменение системных переменных среды  
В открывшемся окне -> Переменные среды  
Далее, необходимо выбрать переменную Path -> Изменить  
Создать -> ввести путь до файла -> ОК
## Из исходных кодов
Для компилирования приложения потребуется:
- Компилятор языка программирования GO
- Система контроля версий git
- Исходные файлы приложения.
Сначала необходимо скачать и установить компилятор языка программирования GO. Для этого, необходимо перейти по ссылке https://go.dev/doc/install . На странице сайта будет автоматически представлена последняя версия компилятора подходящая операционной системе.
Далее, необходимо скачать и установить систему контроля версий git (https://git-scm.com/), на сайте будет так же автоматически предложена самая последняя и подходящая версия.
После установки компилятора и системы контроля версий, необходимо произвести клонирование исходных кодов приложения. Выполнить это можно, введя в терминале следующую команду:
```bash
git clone https://github.com/hashicorp/terraform.git
```
Обратите внимание, что клонирование будет происходить в директорию, из которой происходил вызов команды.
После клонирования, можно приступить к сборке приложения.
Для этого необходимо перейти в каталог, в который произошло клонирование исходных кодов и выполнить команду в терминале:
```bash
go install
```
Или  
```bash
go build
```
Результатом выполнения данной программы станет бинарный файл terraform. 
Полученный файл необходимо поместить в каталог `/usr/local/bin` для MacOS или Linux, либо в любой каталог и указать его путь в переменных окружения для ОС Windows.
После всех действий, команда `terraform -help` должна выводить информацию в терминал.
Полезные ссылки:
- https://learn.hashicorp.com/tutorials/terraform/install-cli
- https://stackoverflow.com/questions/1618280/where-can-i-set-path-to-make-exe-on-windows
