Функция доступна в провайдере версии 2.3 и выше.

_Data source_ функция **decort_bservice_group** служит для получения информации о вычислительной группе базового сервиса. Базовый сервис (basic service) может быть шаблоном, на основе которого создаются вычислительные мощности (computes). Вычислительные группы (computes) создаются на основе базового сервиса.

## Аргументы
_Data source_ функция **decort_bservice_group** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | :---: | --- | 
| service_id | int | :heavy_check_mark: | ID сервиса |
| compgroup_id | int | :heavy_check_mark: | ID вычислительной группы |


## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_bservice_group** возвращает следующие параметры:

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | ID аккаунта |
| account_name | string | Название аккаунта |
| computes | [см. ниже](#описание-блока-computes) | Список компьютов |
| compgroup_id | int | ID вычислительной группы |
| compgroup_name | string | Название вычислительной группы |
| consistency | bool | Флаг, последовательность |
| cpu | int | Кол-во ядер |
| created_by | string | Кем создан сервис |
| created_time | int | Время создания сервиса |
| deleted_by | string | Кем удален сервис |
| deleted_time | int | Время удаления сервиса |
| disk | int | Кол-во используемого места на дисках, ГБ |
| driver | string | Используемый драйвер |
| extnets | []int | Список ID внешних сетей |
| gid | int | Grid id |
| guid | int | Внутренний ID группы |
| image_id | int | ID образа, который используется в вычислительной группе |
| milestones | int | Вехи |
| service_id | int | ID сервиса |
| parents | []int | Список родительских групп |
| ram | int | Кол-во RAM, МБ |
| rg_id | int | ID ресурсной группы |
| rg_name | string | Название ресурсной группы |
| role | string | Роль(тег) группы |
| sep_id | int | ID sep |
| seq_no | int | Номер последовательности |
| status | string | Статус сервиса |
| tech_status | string | Технический статус сервиса |
| timeout_start | int | Таймаут перед стартом |
| updated_by | string | Кем сервис был обновлен |
| updated_time | int | Время последнего обновления |
| vinses | []int | Список ID виртуальных сетей |

### Описание блока computes

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| chipset | string | Чипсет |
| id | int | ID виртуальной машины |
| ip_addresses | []string | Список IP адрессов |
| os_users | []Struct [см. ниже](#описание-структуры-os-users) | Имена и пароли пользователей гостевой ОС, установленные платформой при создании виртуальной машины. |

### Описание структуры os users

| Параметр | Тип | Описание |
| --- | --- | --- |
| login | string | Логин |
| password | string | Пароль |

## Пример использования
Пример вызова _data source_ функции **decort_bservice_group**:
```terraform
data "decort_bservice_group" "bsg" {
  #id сервиса
  #обязательный параметр
  #тип - целое число
  service_id = 11111

  #id вычислительной группы
  #обязательный параметр
  #тип - целое число
  compgroup_id = 12121

}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.9.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_bservice_group** в переменной `data.decort_bservice_group.bsg` будут сохранены возвращаемые значения.
