Функция доступна в провайдере версии 4.8.0 и выше.

_Data source_ функция **decort_cb_extnet_reserved_ip_list** служит для получения информации о зарезервированных IP адресах или пуле адресов

## Аргументы
_Data source_ функция **decort_cb_extnet_reserved_ip_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| account_id | int | :heavy_check_mark: | Идентификатор аккаунта, для которого зарезервированны ресурсы |
| extnet_id | int | :x: | ID сети |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_extnet_reserved_ip_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| extnet_id | int | ID сети |
| reservations | []struct [см. ниже](#описание-структуры-reservations) | список зарезервированных ресурсов |

### Описание структуры reservations
| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | ID аккаунта |
| client_type | string | Тип клиента |
| domainname | string | Имя домена |
| hostname | string | Имя хоста |
| desc | string | Описание |
| ip | string | IP-адрес |
| mac | string | MAC-адрес |
| type | string | Тип |
| vm_id | int | ID виртуальной машины |

## Пример использования
Пример вызова _data source_ функции **decort_cb_extnet_reserved_ip_list**:
```terraform
data "decort_cb_extnet_reserved_ip" "ex_reserved_ip" {
  #идентификатор аккаунта, для которого зарезервированны ресурсы
  #обязательный параметр
  #тип - целое число
  account_id = 1111

  #идентификатор сети
  #опциональный параметр
  #тип - целое число
  #extnet_id = 1111
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.9.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_cb_extnet_reserved_ip_list** в переменной `data.decort_cb_extnet_reserved_ip_list.ex_reserved_ip` будут сохранены возвращаемые значения.
