Функция доступна в провайдере версии 4.9.0 и выше.

_Data source_ функция **decort_cb_sep_and_pools_available_list** служит для получения информации обо всех доступных пользователю storage endpoints и pools

## Аргументы

_Data source_ функция **decort_cb_sep_and_pools_available_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| account_id | int | :heavy_check_mark: | Идентификатор аккаунта |
| rg_id | string | :x: | Идентификатор ресурсной группы |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_cb_sep_and_pools_available_list** возвращает в указанную при вызове переменную, в поле _items_, массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| sep_id | int | ID storage endpoint provider |
| sep_name | string | Наименование SEP |
| sep_type | string | Тип SEP |
| pools | []Struct [см. ниже](#описание-структуры-pools) | Список пулов в SEP |

### Описание структуры pools
| Параметр | Тип | Описание |
| --- | --- | --- |
| name | string | Наименование пула |
| types | []string | Список типов пула |
| system | bool | Флаг системного пула |

## Пример использования

Пример вызова _data source_ функции **decort_cb_available_sep_and_pools_lis**:

```terraform
data "decort_cb_sep_and_pools_available_list" "ap" {
   #идентификатор аккаунта
   #обязательный параметр
   #тип - целое число
   account_id = 1111

   #идентификатор ресурсной группы
   #опциональный параметр
   #тип - целое число    
   #rg_id = 1111
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.9.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_cb_sep_and_pools_available_list** в переменной `data.decort_cb_sep_and_pools_available_list.ap.items` будут сохранены возвращаемые значения.
