Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_vins_ext_net_list** служит для получения списка внешних сетей для внутренней сети.

## Аргументы
_Data source_ функция **decort_cb_vins_ext_net_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| vins_id | int | :heavy_check_mark: | ID vins |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_vins_ext_net_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| default_gw | string | Шлюз по умолчанию |
| ext_net_id | int | ID внешней сети |
| ip | string | IP внешней сети |
| prefix_len | int | Длина префикса |
| status | string | Статус |
| tech_status | string | Технический статус |

## Пример использования
Пример вызова _data source_ функции **decort_cb_vins_ext_net_list**:
```terraform
data "decort_cb_vins_ext_net_list" "enl" {
  #id желаемого vins
  #обязательный параметр
  #тип - целое число
  vins_id = 10101
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.9.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_cb_vins_ext_net_list** в переменной `data.decort_cb_vins_ext_net_list.enl` будут сохранены возвращаемые значения.
