Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_extnet_static_route_list** служит для получения списка статических маршрутов для внешней сети extnet.

## Аргументы
_Data source_ функция **decort_cb_extnet_static_route_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| extnet_id | int | :heavy_check_mark: | ID внешней сети |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_extnet_static_route_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| compute_ids | []int | Список ID compute, которым предоствавлен доступ |
| destination | string | IP целевой сети |
| gateway | string | IP шлюза |
| guid | string | ID ресурса |
| netmask | string | Маска сети |
| route_id | int | ID статического маршрута |

## Пример использования
Пример вызова _data source_ функции **decort_cb_extnet_static_route_list**:
```terraform
data "decort_cb_extnet_static_route_list" "list" {
  #id extnet в котором добавлены routes
  #обязательный параметр
  #тип - целое число
  extnet_id = 1111
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.9.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_cb_extnet_static_route_list** в переменной `data.decort_cb_extnet_static_route_list.ensr.items` будут сохранены возвращаемые значения.
