Функция доступна в провайдере версии 2.1 и выше.

_Resource_ функция **decort_snapshot** служит для управления снапшотами. Снапшот позволяет делать снимки данных с диска, а после этого их восстанавливать. Для успешного восстановления данных через снапшот, необходимо убедиться, что [compute](link will available soon) (вычислительные мощности) остановлен.

## Аргументы
_Resource_ функция **decort_snapshot** для создания снапшота принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| compute_id | int | :heavy_check_mark: | ID вычислительной мощности |
| label | string | :heavy_check_mark: | Наименование снапшота |
| rollback | bool | :x: | Флаг отката<br/>по умолчанию - false<br/>если флаг был изменен с false на true,<br/>то произойдет восстановление данных из снапшота<br/>Флаг используется после создания ресурса. |
| snapshot_delete_async | bool | :x: | Флаг для удаления снапшотов в асинхронном режиме |

## Возвращаемые значения
В случае успешного выполнения _resource_ функция **decort_snapshot** возвращает в указанную при вызове переменную следующие значения:

| Параметр | Тип | Описание |
| --- | --- | --- |
| compute_id | int | ID вычислительной мощности |
| disks | []int | Диски снапшота |
| guid | string | Guid снапшота |
| label | string | Наименование снапшота |
| rollback | bool | Флаг отката |
| snapshot_delete_async | bool | Флаг для удаления снапшотов в асинхронном режиме |
| timestamp | int | Время создания снапшота |

## Пример использования
Пример вызова _resource_ функции **decort_snapshot**:
```terraform
resource "decort_snapshot" "s" {
  #обязательный параметр
  #id вычислительной мощности
  #тип - целое число
  #используется при создании
  compute_id = 24074

  #обязательный параметр
  #наименование snapshot
  #тип - строка
  #используется при создании
  label = "test_ssht_3"

  #флаг отката
  #опциональный параметр
  #если флаг был изменен с false на true, то произойдет откат
  #по умолчанию - false
  #тип - булев
  #используется при обновлении
  #rollback = false

  #флаг для удаление снапшота асинхронном режиме
  #опциональный параметр
  #по умолчанию - false
  #тип - булев
  #используется при удалении
  #delete_async_mode = true

}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.9.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_snapshot** в переменной `decort_snapshot.s` будут сохранены возвращаемые значения.
